package org.simplericity.jettyconsole.jsp;

import org.simplericity.jettyconsole.api.JettyConsolePluginBase;
import org.eclipse.jetty.webapp.WebAppContext;

import java.util.Arrays;
import java.util.List;
import java.util.ArrayList;

/**
 */
public class JspPlugin extends JettyConsolePluginBase {

    private static String[] __dftConfigurationClasses =
    {
        "org.eclipse.jetty.webapp.WebInfConfiguration",
        "org.eclipse.jetty.webapp.WebXmlConfiguration",
        "org.eclipse.jetty.webapp.MetaInfConfiguration",
        "org.eclipse.jetty.webapp.FragmentConfiguration",
        "org.eclipse.jetty.webapp.JettyWebXmlConfiguration",
        "org.eclipse.jetty.webapp.TagLibConfiguration"
    } ;

    public JspPlugin() {
        super(JspPlugin.class);
    }

    /*
    @Override
    public void bootstrap() {
        String file = getClass().getClassLoader().getResource("WEB-INF/web.xml").getFile();
        if(!file.endsWith(".jar")) {
            System.err.println("JSP support requires that the WAR file is called ");
            System.exit(-1);
        }
    }
    */

    @Override
    public void beforeStart(WebAppContext context) {

        // Can be set to true / removed once
        // https://bugs.eclipse.org/bugs/show_bug.cgi?id=310051 is fixed
        boolean postJetty702 = false;

        String[] current = postJetty702 ? context.getConfigurationClasses(): __dftConfigurationClasses;

        List<String> cfn = new ArrayList<String>(Arrays.asList(current));
        cfn.add(JasperInUnpackedWarUglyHackConfiguration.class.getName());
        context.setConfigurationClasses(cfn.toArray(new String[cfn.size()]));
    }
}
